Subject: Re: bug#18767: 24.4; incorrect byte-compile on arithmatic comparisons

From: Shigeru Fukaya <[email-masked]>
Date: Wed, 22 Oct 2014 18:16:42 +0900

I think your change of reversion will cause byte-compile error when
more than two args are specified.
Maybe you had better call byte-compile-normal-call for that case at least.

>loop over all args, doing "byte-compile-form" + "dup", and then apply
>the comparisons backward, combining them with "and".

Alternative is,

If non-first args are all constants or simple reference, fold them with AND,
otherwise call them at once by byte-compile-normal-call.

Shigeru

>Version:24.5
>
>> byte-compile of arithmatic comparison operators on more than two
>> arguments is incorrect.
>
>Indeed, I was not very awake when I committed that code.  I just
>reverted the change so the byte-compiler simply doesn't optimize this case.
>To do any better, I think we'll have to do something like:
>
>loop over all args, doing "byte-compile-form" + "dup", and then apply
>the comparisons backward, combining them with "and".
>
>
>        Stefan